import 'dart:convert';
import 'dart:io';

Future<void> main() async {
  stdout.write("Enter the feature's name: ");
  var featureName = stdin.readLineSync(encoding: utf8);
  if ((featureName?.trim() ?? '').isEmpty) {
    throw Exception('Feature name must not be null or empty');
  }

  if (!await Directory('${Directory.current.path}/lib/features').exists()) {
    Directory('${Directory.current.path}/lib/features').createSync();
  }

  createFolderStructure(featureName: featureName!.trim());
}

void createFolderStructure({required String featureName}) {
  Directory('${Directory.current.path}/lib/features/$featureName').create().then((Directory featureDir) {
    Directory('${featureDir.path}/views').create();

    Directory('${featureDir.path}/functionals').create().then((Directory functionalsDir) {
      Directory('${functionalsDir.path}/service').create().then((Directory serviceDir) async {
        File service = await File('${serviceDir.path}/service.dart').create(recursive: true).then((file) => file);
        service.writeAsString(
            "import 'package:codestage_requester/codestage_requester.dart';\nimport 'package:dr_leahu_app/configurationEnvironment/environment.dart';\n\nclass Service extends CdsService {\nService() : super(baseUrl: Environment().usedConfiguration!.baseUrl);\n}\n");
      });

      Directory('${functionalsDir.path}/listings').create().then((Directory listingsDir) async {
        File listings = await File('${listingsDir.path}/listings.dart').create(recursive: true).then((file) => file);
        listings.writeAsString("import 'package:codestage_architecture/codestage_architecture.dart';\n\nclass Listings extends CdsListing {}\n");
      });

      Directory('${functionalsDir.path}/models').create();

      Directory('${functionalsDir.path}/enums').create();

      Directory('${functionalsDir.path}/paramsBundle').create();

      Directory('${functionalsDir.path}/components').create();
    });
  });
}
